diff -r ec894ddf18f6 trytond/modules/calendar/calendar_.py
--- a/trytond/modules/calendar/calendar_.py	Wed Jul 25 20:55:21 2012 +0200
+++ b/trytond/modules/calendar/calendar_.py	Mon Sep 24 20:36:40 2012 +0200
@@ -1365,60 +1276,53 @@
             res['email'] = attendee.value
         res['status'] = ''
         if hasattr(attendee, 'partstat_param'):
-            if attendee.partstat_param.lower() in dict(self.status.selection):
+            if attendee.partstat_param.lower() in dict(cls.status.selection):
                 res['status'] = attendee.partstat_param.lower()
         res['attendee'] = attendee.serialize()
         return res
 
-    def attendee2attendee(self, attendee):
+    def attendee2attendee(self):
         '''
         Return a attendee instance of vobject for attendee
-
-        :param attendee: a BrowseRecord of calendar.event.attendee
-        :return: a attendee instance of vobject
         '''
         res = None
-        if attendee.attendee:
+        if self.attendee:
             res = vobject.base.textLineToContentLine(
-                    str(attendee.attendee).replace('\r\n ', ''))
+                    str(self.attendee).replace('\r\n ', ''))
         else:
             res = vobject.base.ContentLine('ATTENDEE', [], '')
 
-        if attendee.status:
+        if self.status:
             if hasattr(res, 'partstat_param'):
                 if res.partstat_param.lower() in dict(self.status.selection):
-                    res.partstat_param = attendee.status.upper()
+                    res.partstat_param = self.status.upper()
             else:
-                res.partstat_param = attendee.status.upper()
+                res.partstat_param = self.status.upper()
         elif hasattr(res, 'partstat_param'):
             if res.partstat_param.lower() in dict(self.status.selection):
                 del res.partstat_param
 
-        res.value = 'MAILTO:' + attendee.email
+        res.value = 'MAILTO:' + self.email
         return res
 
-Attendee()
-
 
 class EventAttendee(ModelSQL, ModelView):
     'Attendee'
-    _description = __doc__
-    _name = 'calendar.event.attendee'
+    __name__ = 'calendar.event.attendee'
     _inherits = {'calendar.attendee': 'calendar_attendee'}
-
     calendar_attendee = fields.Many2One('calendar.attendee',
         'Calendar Attendee', required=True, ondelete='CASCADE', select=True)
     event = fields.Many2One('calendar.event', 'Event', ondelete='CASCADE',
         required=True, select=True)
 
-    def create(self, values):
-        event_obj = Pool().get('calendar.event')
+    @staticmethod
+    def create(cls, values):
+        Event = Pool().get('calendar.event')
         if values.get('event'):
             # Update write_date of event
-            event_obj.write(values['event'], {})
-        res = super(EventAttendee, self).create(values)
-        attendee = self.browse(res)
-        event = attendee.event
+            Event.write([Event(values['event'])], {})
+        event_attendee = super(EventAttendee, cls).create(values)
+        event = event_attendee.event
         if (event.calendar.owner
                 and (event.organizer == event.calendar.owner.email
                     or (event.parent
@@ -1432,36 +1336,72 @@
                         if x.email != event.parent.organizer]
             if attendee_emails:
                 with Transaction().set_user(0):
-                    event_ids = event_obj.search([
-                        ('uuid', '=', event.uuid),
-                        ('calendar.owner.email', 'in', attendee_emails),
-                        ('id', '!=', event.id),
-                        ('recurrence', '=', event.recurrence),
-                        ])
-                    for event_id in event_ids:
-                        self.copy(res, default={
-                            'event': event_id,
-                            })
-        return res
+                    events = Event.search([
+                            ('uuid', '=', event.uuid),
+                            ('calendar.owner.email', 'in', attendee_emails),
+                            ('id', '!=', event.id),
+                            ('recurrence', '=', event.recurrence),
+                            ])
+                    for event in events:
+                        cls.copy([event_attendee], default={
+                                'event': event.id,
+                                })
+        return event_attendee
 
-    def write(self, ids, values):
-        event_obj = Pool().get('calendar.event')
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        event_ids = [x.event.id for x in self.browse(ids)]
+    @classmethod
+    def write(cls, event_attendees, values):
+        Event = Pool().get('calendar.event')
+        events = [x.event.id for x in event_attendees]
         if values.get('event'):
-            event_ids.append(values['event'])
-        if event_ids:
+            events.append(Event(values['event']))
+        if events:
             # Update write_date of event
-            event_obj.write(event_ids, {})
+            Event.write(events, {})
 
         if 'email' in values:
             values = values.copy()
             del values['email']
 
-        res = super(EventAttendee, self).write(ids, values)
-        attendees = self.browse(ids)
-        for attendee in attendees:
+        super(EventAttendee, cls).write(event_attendees, values)
+        for event_attendee in event_attendees:
+            event = event_attendee.event
+            if event.calendar.owner \
+                    and (event.organizer == event.calendar.owner.email \
+                    or (event.parent \
+                    and event.parent.organizer == event.calendar.owner.email)):
+                if event.organizer == event.calendar.owner.email:
+                    attendee_emails = [x.email for x in event.attendees
+                            if x.email != event.organizer]
+                else:
+                    attendee_emails = [x.email for x in event.parent.attendees
+                            if x.email != event.parent.organizer]
+                if attendee_emails:
+                    with Transaction().set_user(0):
+                        other_attendees = cls.search([
+                                ('event.uuid', '=', event.uuid),
+                                ('event.calendar.owner.email', 'in',
+                                    attendee_emails),
+                                ('id', '!=', event_attendee.id),
+                                ('event.recurrence', '=',
+                                    event.recurrence),
+                                ('email', '=', event_attendee.email),
+                                ])
+                        cls.write(other_attendees,
+                            event_attendee._attendee2update())
+
+    @classmethod
+    def delete(cls, event_attendees):
+        pool = Pool()
+        Event = pool.get('calendar.event')
+        Attendee = pool.get('calendar.attendee')
+
+        calendar_attendees = [a.calendar_attendee for a in event_attendees]
+        events = [x.event for x in event_attendees]
+        if events:
+            # Update write_date of event
+            Event.write(events, {})
+
+        for attendee in event_attendees:
             event = attendee.event
             if event.calendar.owner \
                     and (event.organizer == event.calendar.owner.email \
@@ -1475,57 +1415,16 @@
                             if x.email != event.parent.organizer]
                 if attendee_emails:
                     with Transaction().set_user(0):
-                        attendee_ids = self.search([
-                            ('event.uuid', '=', event.uuid),
-                            ('event.calendar.owner.email', 'in',
-                                attendee_emails),
-                            ('id', '!=', attendee.id),
-                            ('event.recurrence', '=',
-                                event.recurrence),
-                            ('email', '=', attendee.email),
-                            ])
-                        self.write(attendee_ids, self._attendee2update(
-                            attendee))
-        return res
-
-    def delete(self, ids):
-        event_obj = Pool().get('calendar.event')
-        attendee_obj = Pool().get('calendar.attendee')
-
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        event_attendees = self.browse(ids)
-        calendar_attendee_ids = [a.calendar_attendee.id \
-                for a in event_attendees]
-        event_ids = [x.event.id for x in event_attendees]
-        if event_ids:
-            # Update write_date of event
-            event_obj.write(event_ids, {})
-
-        for attendee in self.browse(ids):
-            event = attendee.event
-            if event.calendar.owner \
-                    and (event.organizer == event.calendar.owner.email \
-                    or (event.parent \
-                    and event.parent.organizer == event.calendar.owner.email)):
-                if event.organizer == event.calendar.owner.email:
-                    attendee_emails = [x.email for x in event.attendees
-                            if x.email != event.organizer]
-                else:
-                    attendee_emails = [x.email for x in event.parent.attendees
-                            if x.email != event.parent.organizer]
-                if attendee_emails:
-                    with Transaction().set_user(0):
-                        attendee_ids = self.search([
-                            ('event.uuid', '=', event.uuid),
-                            ('event.calendar.owner.email', 'in',
-                                attendee_emails),
-                            ('id', '!=', attendee.id),
-                            ('event.recurrence', '=',
-                                event.recurrence),
-                            ('email', '=', attendee.email),
-                            ])
-                        self.delete(attendee_ids)
+                        attendees = cls.search([
+                                ('event.uuid', '=', event.uuid),
+                                ('event.calendar.owner.email', 'in',
+                                    attendee_emails),
+                                ('id', '!=', attendee.id),
+                                ('event.recurrence', '=',
+                                    event.recurrence),
+                                ('email', '=', attendee.email),
+                                ])
+                        cls.delete(attendees)
             elif event.calendar.owner \
                     and ((event.organizer \
                     or (event.parent and event.parent.organizer)) \
@@ -1535,89 +1434,76 @@
                 else:
                     organizer = event.parent.organizer
                 with Transaction().set_user(0):
-                    attendee_ids = self.search([
-                        ('event.uuid', '=', event.uuid),
-                        ('event.calendar.owner.email', '=', organizer),
-                        ('id', '!=', attendee.id),
-                        ('event.recurrence', '=', event.recurrence),
-                        ('email', '=', attendee.email),
-                        ])
-                    if attendee_ids:
-                        self.write(attendee_ids, {
-                            'status': 'declined',
-                            })
-        res = super(EventAttendee, self).delete(ids)
-        if calendar_attendee_ids:
-            attendee_obj.delete(calendar_attendee_ids)
-        return res
+                    attendees = cls.search([
+                            ('event.uuid', '=', event.uuid),
+                            ('event.calendar.owner.email', '=', organizer),
+                            ('id', '!=', attendee.id),
+                            ('event.recurrence', '=', event.recurrence),
+                            ('email', '=', attendee.email),
+                            ])
+                    if attendees:
+                        cls.write(attendees, {
+                                'status': 'declined',
+                                })
+        super(EventAttendee, cls).delete(event_attendees)
+        if calendar_attendees:
+            Attendee.delete(calendar_attendees)
 
-    def copy(self, ids, default=None):
-        attendee_obj = Pool().get('calendar.attendee')
+    @classmethod
+    def copy(cls, event_attendees, default=None):
+        Attendee = Pool().get('calendar.attendee')
 
-        int_id = False
-        if isinstance(ids, (int, long)):
-            int_id = True
-            ids = [ids]
         if default is None:
             default = {}
         default = default.copy()
-        new_ids = []
-        for attendee in self.browse(ids):
-            default['calendar_attendee'] = attendee_obj.copy(
-                    attendee.calendar_attendee.id)
-            new_id = super(EventAttendee, self).copy(attendee.id,
-                    default=default)
-            new_ids.append(new_id)
-        if int_id:
-            return new_ids[0]
-        return new_ids
+        new_event_attendees = []
+        for event_attendee in event_attendees:
+            default['calendar_attendee'], = Attendee.copy(
+                    [event_attendee.calendar_attendee])
+            new_event_attendees.extend(super(EventAttendee, cls).copy(
+                    [event_attendee], default=default))
+        return new_event_attendees
 
-    def _attendee2update(self, attendee):
-        attendee_obj = Pool().get('calendar.attendee')
-        return attendee_obj._attendee2update(attendee)
+    def _attendee2update(self):
+        return self.calendar_attendee._attendee2update()
 
-    def attendee2values(self, attendee):
-        attendee_obj = Pool().get('calendar.attendee')
-        return attendee_obj.attendee2values(attendee)
+    @staticmethod
+    def attendee2values(attendee):
+        Attendee = Pool().get('calendar.attendee')
+        return Attendee.attendee2values(attendee)
 
-    def attendee2attendee(self, attendee):
-        attendee_obj = Pool().get('calendar.attendee')
-        return attendee_obj.attendee2attendee(attendee)
-
-EventAttendee()
+    def attendee2attendee(self):
+        return self.calendar_attendee.attendee2attendee()
 
 
 class Date(ModelSQL, ModelView):
     'Calendar Date'
-    _description = __doc__
-    _name = 'calendar.date'
+    __name__ = 'calendar.date'
     _rec_name = 'datetime'
-
     date = fields.Boolean('Is Date', help='Ignore time of field "Date", ' \
             'but handle as date only.')
     datetime = fields.DateTime('Date', required=True)
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 1.4: calendar.rdate renamed to calendar.date
         old_table = 'calendar_rdate'
         if TableHandler.table_exist(cursor, old_table):
-            TableHandler.table_rename(cursor, old_table, self._table)
+            TableHandler.table_rename(cursor, old_table, cls._table)
 
-        return super(Date, self).init(module_name)
+        super(Date, cls).__register__(module_name)
 
-    def _date2update(self, date):
-        res = {}
-        res['date'] = date.date
-        res['datetime'] = date.datetime
-        return res
+    def _date2update(self):
+        return {
+            'date': self.date,
+            'datetime': self.datetime,
+            }
 
-    def date2values(self, date):
+    @staticmethod
+    def date2values(date):
         '''
         Convert a date object into values for create or write
-
-        :param date: the date object
-        :return: a dictionary with values
         '''
         res = {}
         if not isinstance(date, datetime.datetime):
@@ -1632,108 +1518,91 @@
                 res['datetime'] = date
         return res
 
-    def date2date(self, date):
+    def date2date(self):
         '''
         Return a datetime for date
-
-        :param date: a BrowseRecord of calendar.date or
-            calendar.exdate
-        :return: a datetime
         '''
-        if date.date:
-            res = date.datetime.date()
+        if self.date:
+            return self.date.datetime.date()
         else:
             # Convert to UTC as sunbird doesn't handle tzid
-            res = date.datetime.replace(tzinfo=tzlocal).astimezone(tzutc)
-        return res
-
-Date()
+            return self.datetime.replace(tzinfo=tzlocal).astimezone(tzutc)
 
 
 class EventRDate(ModelSQL, ModelView):
     'Recurrence Date'
-    _description = __doc__
-    _name = 'calendar.event.rdate'
+    __name__ = 'calendar.event.rdate'
     _inherits = {'calendar.date': 'calendar_date'}
     _rec_name = 'datetime'
-
     calendar_date = fields.Many2One('calendar.date', 'Calendar Date',
             required=True, ondelete='CASCADE', select=True)
     event = fields.Many2One('calendar.event', 'Event', ondelete='CASCADE',
             select=True, required=True)
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 1.4: calendar_rdate renamed to calendar_date
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         old_column = 'calendar_rdate'
         if table.column_exist(old_column):
             table.column_rename(old_column, 'calendar_date')
 
-        return super(EventRDate, self).init(module_name)
+        super(EventRDate, cls).__register__(module_name)
 
-    def create(self, values):
-        event_obj = Pool().get('calendar.event')
+    @classmethod
+    def create(cls, values):
+        Event = Pool().get('calendar.event')
         if values.get('event'):
             # Update write_date of event
-            event_obj.write(values['event'], {})
-        return super(EventRDate, self).create(values)
+            Event.write([Event(values['event'])], {})
+        return super(EventRDate, cls).create(values)
 
-    def write(self, ids, values):
-        event_obj = Pool().get('calendar.event')
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        event_ids = [x.event.id for x in self.browse(ids)]
+    @classmethod
+    def write(cls, event_rdates, values):
+        Event = Pool().get('calendar.event')
+        events = [x.event for x in event_rdates]
         if values.get('event'):
-            event_ids.append(values['event'])
-        if event_ids:
+            events.append(Event(values['event']))
+        if events:
             # Update write_date of event
-            event_obj.write(event_ids, {})
-        return super(EventRDate, self).write(ids, values)
+            Event.write(events, {})
+        super(EventRDate, cls).write(event_rdates, values)
 
-    def delete(self, ids):
-        event_obj = Pool().get('calendar.event')
-        rdate_obj = Pool().get('calendar.date')
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        event_rdates = self.browse(ids)
-        rdate_ids = [a.calendar_date.id for a in event_rdates]
-        event_ids = [x.event.id for x in event_rdates]
-        if event_ids:
+    @classmethod
+    def delete(cls, event_rdates):
+        pool = Pool()
+        Event = pool.get('calendar.event')
+        Date = pool.get('calendar.date')
+        dates = [a.calendar_date for a in event_rdates]
+        events = [x.event for x in event_rdates]
+        if events:
             # Update write_date of event
-            event_obj.write(event_ids, {})
-        res = super(EventRDate, self).delete(ids)
-        if rdate_ids:
-            rdate_obj.delete(rdate_ids)
-        return res
+            Event.write(events, {})
+        super(EventRDate, cls).delete(event_rdates)
+        if dates:
+            Date.delete(dates)
 
-    def _date2update(self, date):
-        date_obj = Pool().get('calendar.date')
-        return date_obj._date2update(date)
+    def _date2update(self):
+        return self.calendar_date._date2update()
 
-    def date2values(self, date):
-        date_obj = Pool().get('calendar.date')
-        return date_obj.date2values(date)
+    @classmethod
+    def date2values(cls, date):
+        Date = Pool().get('calendar.date')
+        return Date.date2values(date)
 
-    def date2date(self, date):
-        date_obj = Pool().get('calendar.date')
-        return date_obj.date2date(date)
-
-EventRDate()
+    def date2date(self):
+        return self.calendar_date.date2date()
 
 
 class EventExDate(EventRDate):
     'Exception Date'
-    _description = __doc__
-    _name = 'calendar.event.exdate'
-
-EventExDate()
+    __name__ = 'calendar.event.exdate'
 
 
 class RRule(ModelSQL, ModelView):
     'Recurrence Rule'
-    _description = __doc__
-    _name = 'calendar.rrule'
+    __name__ = 'calendar.rrule'
     _rec_name = 'freq'
 
     freq = fields.Selection([
@@ -1769,14 +1638,15 @@
         ('sa', 'Saturday'),
         ], 'Week Day', sort=False)
 
-    def __init__(self):
-        super(RRule, self).__init__()
-        self._sql_constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(RRule, cls).__setup__()
+        cls._sql_constraints += [
             ('until_count_only_one',
                 'CHECK(until IS NULL OR count IS NULL OR count = 0)',
                 'Only one of "until" and "count" can be set!'),
-        ]
-        self._constraints += [
+            ]
+        cls._constraints += [
             ('check_bysecond', 'invalid_bysecond'),
             ('check_byminute', 'invalid_byminute'),
             ('check_byhour', 'invalid_byhour'),
@@ -1786,31 +1656,30 @@
             ('check_byweekno', 'invalid_byweekno'),
             ('check_bymonth', 'invalid_bymonth'),
             ('check_bysetpos', 'invalid_bysetpos'),
-        ]
-        self._error_messages.update({
-            'invalid_bysecond': 'Invalid "By Second"',
-            'invalid_byminute': 'Invalid "By Minute"',
-            'invalid_byhour': 'Invalid "By Hour"',
-            'invalid_byday': 'Invalid "By Day"',
-            'invalid_bymonthday': 'Invalid "By Month Day"',
-            'invalid_byyearday': 'Invalid "By Year Day"',
-            'invalid_byweekno': 'Invalid "By Week Number"',
-            'invalid_bymonth': 'Invalid "By Month"',
-            'invalid_bysetpos': 'Invalid "By Position"',
-        })
+            ]
+        cls._error_messages.update({
+                'invalid_bysecond': 'Invalid "By Second"',
+                'invalid_byminute': 'Invalid "By Minute"',
+                'invalid_byhour': 'Invalid "By Hour"',
+                'invalid_byday': 'Invalid "By Day"',
+                'invalid_bymonthday': 'Invalid "By Month Day"',
+                'invalid_byyearday': 'Invalid "By Year Day"',
+                'invalid_byweekno': 'Invalid "By Week Number"',
+                'invalid_bymonth': 'Invalid "By Month"',
+                'invalid_bysetpos': 'Invalid "By Position"',
+                })
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migrate from 1.4: unit_count replaced by until_count_only_one
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         table.drop_constraint('until_count')
-        return super(RRule, self).init(module_name)
+        return super(RRule, cls).__register__(module_name)
 
-    def check_bysecond(self, ids):
-        for rule in self.browse(ids):
-            if not rule.bysecond:
-                continue
-            for second in rule.bysecond.split(','):
+    def check_bysecond(self):
+        if self.bysecond:
+            for second in self.bysecond.split(','):
                 try:
                     second = int(second)
                 except Exception:
@@ -1819,11 +1688,9 @@
                     return False
         return True
 
-    def check_byminute(self, ids):
-        for rule in self.browse(ids):
-            if not rule.byminute:
-                continue
-            for minute in rule.byminute.split(','):
+    def check_byminute(self):
+        if self.byminute:
+            for minute in self.byminute.split(','):
                 try:
                     minute = int(minute)
                 except Exception:
@@ -1832,11 +1699,9 @@
                     return False
         return True
 
-    def check_byhour(self, ids):
-        for rule in self.browse(ids):
-            if not rule.byhour:
-                continue
-            for hour in rule.byhour.split(','):
+    def check_byhour(self):
+        if self.byhour:
+            for hour in self.byhour.split(','):
                 try:
                     hour = int(hour)
                 except Exception:
@@ -1845,11 +1710,9 @@
                     return False
         return True
 
-    def check_byday(self, ids):
-        for rule in self.browse(ids):
-            if not rule.byday:
-                continue
-            for weekdaynum in rule.byday.split(','):
+    def check_byday(self):
+        if self.byday:
+            for weekdaynum in self.byday.split(','):
                 weekday = weekdaynum[-2:]
                 if weekday not in ('SU', 'MO', 'TU', 'WE', 'TH', 'FR', 'SA'):
                     return False
@@ -1864,11 +1727,9 @@
                     return False
         return True
 
-    def check_bymonthday(self, ids):
-        for rule in self.browse(ids):
-            if not rule.bymonthday:
-                continue
-            for monthdaynum in rule.bymonthday.split(','):
+    def check_bymonthday(self):
+        if self.bymonthday:
+            for monthdaynum in self.bymonthday.split(','):
                 try:
                     monthdaynum = int(monthdaynum)
                 except Exception:
@@ -1877,11 +1738,9 @@
                     return False
         return True
 
-    def check_byyearday(self, ids):
-        for rule in self.browse(ids):
-            if not rule.byyearday:
-                continue
-            for yeardaynum in rule.byyearday.split(','):
+    def check_byyearday(self):
+        if self.byyearday:
+            for yeardaynum in self.byyearday.split(','):
                 try:
                     yeardaynum = int(yeardaynum)
                 except Exception:
@@ -1890,11 +1749,9 @@
                     return False
         return True
 
-    def check_byweekno(self, ids):
-        for rule in self.browse(ids):
-            if not rule.byweekno:
-                continue
-            for weeknum in rule.byweekno.split(','):
+    def check_byweekno(self):
+        if self.byweekno:
+            for weeknum in self.byweekno.split(','):
                 try:
                     weeknum = int(weeknum)
                 except Exception:
@@ -1903,11 +1760,9 @@
                     return False
         return True
 
-    def check_bymonth(self, ids):
-        for rule in self.browse(ids):
-            if not rule.bymonth:
-                continue
-            for monthnum in rule.bymonth.split(','):
+    def check_bymonth(self):
+        if self.bymonth:
+            for monthnum in self.bymonth.split(','):
                 try:
                     monthnum = int(monthnum)
                 except Exception:
@@ -1916,11 +1771,9 @@
                     return False
         return True
 
-    def check_bysetpos(self, ids):
-        for rule in self.browse(ids):
-            if not rule.bysetpos:
-                continue
-            for setposday in rule.bysetpos.split(','):
+    def check_bysetpos(self):
+        if self.bysetpos:
+            for setposday in self.bysetpos.split(','):
                 try:
                     setposday = int(setposday)
                 except Exception:
@@ -1929,20 +1782,18 @@
                     return False
         return True
 
-    def _rule2update(self, rule):
+    def _rule2update(self):
         res = {}
         for field in ('freq', 'until_date', 'until', 'count', 'interval',
                 'bysecond', 'byminute', 'byhour', 'byday', 'bymonthday',
                 'byyearday', 'byweekno', 'bymonth', 'bysetpos', 'wkst'):
-            res[field] = rule[field]
+            res[field] = getattr(self, field)
         return res
 
-    def rule2values(self, rule):
+    @classmethod
+    def rule2values(cls, rule):
         '''
         Convert a rule object into values for create or write
-
-        :param rule: teh rule object
-        :return: a dictionary with values
         '''
         res = {}
         for attr in str(rule.value).replace('\\', '').split(';'):
@@ -1969,42 +1820,35 @@
                 res[field] = value
         return res
 
-    def rule2rule(self, rule):
+    def rule2rule(self):
         '''
         Return a rule string for rule
-
-        :param rule: a BrowseRecord of calendar.rrule or
-            calendar.exrule
-        :return: a string
         '''
-        res = 'FREQ=' + rule.freq.upper()
-        if rule.until:
+        res = 'FREQ=' + self.freq.upper()
+        if self.until:
             res += ';UNTIL='
-            if rule.until_date:
-                res += vobject.icalendar.dateToString(rule.until.date())
+            if self.until_date:
+                res += vobject.icalendar.dateToString(self.until.date())
             else:
-                res += vobject.icalendar.dateTimeToString(rule.until\
+                res += vobject.icalendar.dateTimeToString(self.until\
                         .replace(tzinfo=tzlocal).astimezone(tzutc),
                         convertToUTC=True)
-        elif rule.count:
-            res += ';COUNT=' + str(rule.count)
+        elif self.count:
+            res += ';COUNT=' + str(self.count)
         for field in ('freq', 'wkst'):
-            if rule[field]:
-                res += ';' + field.upper() + '=' + rule[field].upper()
+            if getattr(self, field):
+                res += ';' + field.upper() + '=' + getattr(self, field).upper()
         for field in ('interval', 'bysecond', 'byminute', 'byhour',
                 'byday', 'bymonthday', 'byyearday', 'byweekno',
                 'bymonth', 'bysetpos'):
-            if rule[field]:
-                res += ';' + field.upper() + '=' + str(rule[field])
+            if getattr(self, field):
+                res += ';' + field.upper() + '=' + str(getattr(self, field))
         return res
 
-RRule()
-
 
 class EventRRule(ModelSQL, ModelView):
     'Recurrence Rule'
-    _description = __doc__
-    _name = 'calendar.event.rrule'
+    __name__ = 'calendar.event.rrule'
     _inherits = {'calendar.rrule': 'calendar_rrule'}
     _rec_name = 'freq'
 
